  MEMBER()

   OMIT('ThisPart',_VER_C55)
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)
   ! ThisPart

  OMIT('CommentBlock')
    JNData Printer Class
    modified for use as part of a 
    series of articles in Clarion Magazine.

    Copyright 2001 JNData, LLC
    Licensed for use by Clarion Magazine subscribers.
  ! CommentBlock

  INCLUDE('CMPrintr.INC'),ONCE

  MAP
  .

CmagPrinter.Init               PROCEDURE()    ! ,VIRTUAL

                                  CODE
                                  IF SELF.SetCurrentPrn() = 0
                                    SELF.Alive = TRUE
                                  END !IF

                                  RETURN


CmagPrinter.Kill               PROCEDURE()                               ! ,VIRTUAL

                                  CODE

                                  IF SELF.Alive
                                    IF NOT (SELF.FDM &= NULL)
                                      DISPOSE(SELF.FDM)
                                    END !IF

                                    IF NOT (SELF.SaveFDM &= NULL)
                                      DISPOSE(SELF.SaveFDM)
                                    END !IF

                                    SELF.Alive = FALSE


                                  END !IF

                                  RETURN



CmagPrinter.SetCurrentPrn      PROCEDURE(BYTE IfNeeded=0)                               ! ,VIRTUAL,BYTE
ReturnVal   BYTE
DeviceName  CSTRING(32),OVER(SELF.BDM.dmDeviceName)

                                  CODE

                                  IF IfNeeded <> 0    ! Test to see if user had changed printer first
                                    IF DeviceName <> PRINTER{PROPPRINT:Device}
                                      IfNeeded = 0   ! force a refresh
                                    ELSE
                                      ReturnVal = 0  ! no need to refresh the FDM
                                    END !IF
                                  END !IF

                                  IF IfNeeded = 0   ! If refresh is forced
                                    SELF.BDM = PRINTER{PROPPRINT:DevMode} ! Get the base DevMode Structure

                                    IF NOT (SELF.FDM &= NULL)  ! If Full DevMode Exists get rid of it
                                      DISPOSE(SELF.FDM)
                                    END !IF

                                    SELF.FDM &= NEW STRING(SELF.BDM.dmSize + SELF.BDM.dmDriverExtra)
                                    SELF.FDM = PRINTER{PROPPRINT:DevMode}  ! Get Full DEVMODE Structure

                                    ReturnVal = 0   ! Default to a good return
                                  END !IF

                                  RETURN ReturnVal


CMagPrinter.Save            PROCEDURE()                               ! ,VIRTUAL,BYTE

ReturnVal          BYTE

                                  CODE
                                  ReturnVal = SELF.SetCurrentPrn()

                                  IF (SELF.BDM.dmSize + SELF.BDM.dmDriverExtra) = 0
                                    ReturnVal = 1  ! Bad
                                  END !IF

                                  IF ReturnVal = 0  ! If we are still good to go

                                    IF NOT (SELF.SaveFDM &= NULL)
                                      DISPOSE(SELF.SaveFDM)
                                    END !IF

                                    SELF.SaveFDM &= NEW STRING(SELF.BDM.dmSize + SELF.BDM.dmDriverExtra)
                                    IF (SELF.SaveFDM &= NULL)
                                      ReturnVal = 1 ! Bad memory allocation
                                    END !IF 

                                    SELF.SaveFDM = PRINTER{PROPPRINT:DevMode}  ! Get Full DEVMODE Structure

                                  END !IF

                                  RETURN ReturnVal


CMagPrinter.Restore         PROCEDURE()                               ! ,VIRTUAL,BYTE

ReturnVal          BYTE

TempName           CSTRING(32)  ! for Grabbing the first 32 bytes of SELF.SaveFDM

TempDevMode        GROUP(DevMode)
                   END !GROUP

SaveDeviceName     LIKE(TempName)

                                CODE

                                ReturnVal = 1  !   Default to Bad

                                SaveDeviceName = PRINTER{PROPPRINT:Device}  ! Save Current Printer if Calls fail

                                IF (SELF.SaveFDM &= NULL)  ! Never saved a FDM
                                  ReturnVal = 1
                                ELSE
                                  ReturnVal = 0  ! Restorable from memory
                                END !IF

                                IF ReturnVal = 0  ! If we have a usable SaveFDM
                                  TempName = SELF.SaveFDM[1 : 32]

                                  PRINTER{PROPPRINT:Device} = CLIP(TempName)

                                  IF CLIP(TempName) <> CLIP(PRINTER{PROPPRINT:Device}) ! If the Printer is not available
                                    ReturnVal = 1

                                  ELSE
                                    TempDevMode = PRINTER{PROPPRINT:DevMode}
                                    IF LEN(SELF.SaveFDM) <> (TempDevMode.dmSize + TempDevMode.dmDriverExtra)  ! If the current printer FullDevMode does not match what was saved
                                      ReturnVal = 1

                                    ELSE
                                      PRINTER{PROPPRINT:DevMode} = SELF.SaveFDM  ! Set the full Printer Setting Structure to Full DevMode

                                      ReturnVal = SELF.SetCurrentPrn()   ! Set SELF.CurrentPrinter
                                    END !IF

                                  END !IF
                                END !IF

                                IF ReturnVal <> 0  ! If something went wrong
                                  PRINTER{PROPPRINT:Device} = SaveDeviceName ! Set Printer back to Default
                                END !IF

                                RETURN ReturnVal


CmagPrinter.GetDeviceName      PROCEDURE()                               ! ,STRING
DeviceName         CSTRING(32),OVER(SELF.BDM.dmDeviceName)

                                  CODE
                                  SELF.SetCurrentPrn(1)  ! Refresh if needed
                                  RETURN DeviceName


CMagPrinter.GetFormName        PROCEDURE()                               ! ,STRING
FormName           CSTRING(32),OVER(SELF.BDM.dmFormName)

                                  CODE
                                  SELF.SetCurrentPrn(1)
                                  RETURN FormName


CMagPrinter.GetPort            PROCEDURE()               ! ,STRING

                              CODE
                              
                              RETURN PRINTER{PROPPRINT:Port}


CmagPrinter.SetPort            PROCEDURE(STRING PortName)

                              CODE

                              PRINTER{PROPPRINT:Port} = CLIP(PortName)

                              RETURN


CMagPrinter.GetPrinttoFile     PROCEDURE()               ! ,BYTE

                              CODE
                              
                              RETURN PRINTER{PROPPRINT:PrinttoFile}


CmagPrinter.SetPrinttoFile     PROCEDURE(BYTE Flag)

                              CODE

                              PRINTER{PROPPRINT:PrinttoFile} = Flag

                              RETURN


CmagPrinter.GetFileName        PROCEDURE()               ! ,STRING

                              CODE

                              RETURN PRINTER{PROPPRINT:PRintToName}


CmagPrinter.SetFileName        PROCEDURE(STRING FileName)

                              CODE

                              PRINTER{PROPPRINT:PrintToName} = CLIP(Filename)

                              RETURN


CmagPrinter.IsFieldValid       PROCEDURE(LONG BitMask)                   ! ,BYTE
ReturnVal       BYTE

                                  CODE

                                  CASE BitMask
                                    OF PrnFieldValue:Orientation
                                    OROF PrnFieldValue:PaperSize
                                    OROF PrnFieldValue:PaperLength
                                    OROF PrnFieldValue:PaperWidth
                                    OROF PrnFieldValue:Scale
                                    OROF PrnFieldValue:Copies
                                    OROF PrnFieldValue:DefaultSource
                                    OROF PrnFieldValue:PrintQuality
                                    OROF PrnFieldValue:Color
                                    OROF PrnFieldValue:Duplex
                                    OROF PrnFieldValue:YResolution
                                    OROF PrnFieldValue:TTOption
                                    OROF PrnFieldValue:Collate
                                      ReturnVal = TRUE
                                    ELSE
                                      ReturnVal = FALSE

                                  END !CASE

                                  RETURN ReturnVal


CmagPrinter.IsFieldInitialized     PROCEDURE(LONG BitMask)                 ! ,BYTE
ReturnVal       BYTE

                                  CODE
                                    SELF.SetCurrentPrn(1)  ! Refresh if needed

                                    IF SELF.IsFieldValid(BitMask) AND (BAND(SELF.BDM.dmFields,BitMask) = BitMask)
                                      ReturnVal = TRUE
                                    ELSE
                                      ReturnVal = FALSE
                                    END !IF

                                  RETURN ReturnVal


CmagPrinter.GetFieldName       PROCEDURE(LONG BitMask)                  ! ,STRING
            ! Note: Can easily be overloaded with a BYTE parameter to designate a language.
ReturnString    STRING(40)

                                  CODE

                                  CASE BitMask
                                    OF PrnFieldValue:Orientation
                                      ReturnString = 'Orientation'

                                    OF PrnFieldValue:PaperSize
                                      ReturnString = 'Paper Size'

                                    OF PrnFieldValue:PaperLength
                                      ReturnString = 'Paper Length'

                                    OF PrnFieldValue:PaperWidth
                                      ReturnString = 'Paper Width'

                                    OF PrnFieldValue:Scale
                                      ReturnString = 'Scale'

                                    OF PrnFieldValue:Copies
                                      ReturnString = 'Copies'

                                    OF PrnFieldValue:DefaultSource
                                      ReturnString = 'Default Source (Bin)'

                                    OF PrnFieldValue:PrintQuality
                                      ReturnString = 'Print Quality'

                                    OF PrnFieldValue:Color
                                      ReturnString = 'Color'

                                    OF PrnFieldValue:Duplex
                                      ReturnString = 'Duplex'

                                    OF PrnFieldValue:YResolution
                                      ReturnString = 'Y Resolution'

                                    OF PrnFieldValue:TTOption
                                      ReturnString = 'TrueType Font Mode'

                                    OF PrnFieldValue:Collate
                                      ReturnString = 'Collate'

                                    ELSE
                                      ReturnString = '*Unnamed Field*'

                                  END !CASE

                                  RETURN ReturnString


CmagPrinter.GetFieldValue       PROCEDURE(LONG BitMask,BYTE FromProp=0)                  ! ,LONG
ReturnVal       LONG

                                  CODE

                                  SELF.SetCurrentPrn(1)

                                    CASE BitMask
                                      OF PrnFieldValue:Orientation
                                        ReturnVal = SELF.BDM.dmOrientation   ! Is not PROPPRINT for Orientation

                                      OF PrnFieldValue:PaperSize
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:paper}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmPaperSize
                                        END !IF

                                      OF PrnFieldValue:PaperLength
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:PaperHeight}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmPaperLength
                                        END !IF

                                      OF PrnFieldValue:PaperWidth
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:PaperWidth}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmPaperWidth
                                        END !IF

                                      OF PrnFieldValue:Scale
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:Percent}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmScale
                                        END !IF

                                      OF PrnFieldValue:Copies
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:Copies}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmCopies
                                        END !IF

                                      OF PrnFieldValue:DefaultSource
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:PaperBin}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmDefaultSource
                                        END !IF

                                      OF PrnFieldValue:PrintQuality
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:Resolution}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmPrintQuality
                                        END !IF

                                      OF PrnFieldValue:Color
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:Color}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmColor
                                        END !IF

                                      OF PrnFieldValue:Duplex
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:Duplex}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmDuplex
                                        END !IF

                                      OF PrnFieldValue:YResolution
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:YResolution}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmYResolution
                                        END !IF

                                      OF PrnFieldValue:TTOption
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:FontMode}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmTTOption
                                        END !IF

                                      OF PrnFieldValue:Collate
                                        IF FromProp
                                          ReturnVal = PRINTER{PROPPRINT:collate}
                                        ELSE
                                          ReturnVal = SELF.BDM.dmCollate
                                        END !IF

                                      ELSE
                                        ReturnVal = 0

                                    END !CASE

                                  RETURN ReturnVal


CmagPrinter.SetFieldValue      PROCEDURE(LONG BitMask,LONG Value)                 

                                  CODE

 ! Orientation has no PROPPRINT Equate
 ! PROPPRINT:paper           EQUATE(07B01H)  ! standard paper size (PAPER:xxx)
 ! PROPPRINT:paperheight     EQUATE(07B02H)  ! paper height (in 10th mm)
 ! PROPPRINT:paperwidth      EQUATE(07B03H)  ! paper width (in 10th mm)
 ! PROPPRINT:percent         EQUATE(07B04H)  ! scaling factor
 ! PROPPRINT:copies          EQUATE(07B05H)  ! number of copies
 ! PROPPRINT:paperbin        EQUATE(07B06H)  ! paper source (PAPERBIN:xxx)
 ! PROPPRINT:resolution      EQUATE(07B07H)  ! in DPI or RESOLUTION:xxx)
 ! PROPPRINT:color           EQUATE(07B08H)  ! 1=mono, 2=color
 ! PROPPRINT:duplex          EQUATE(07B09H)  ! duplex mode (DUPLEX::xxx)
 ! PROPPRINT:yresolution     EQUATE(07B0AH)  ! in DPI
 ! PROPPRINT:fontmode        EQUATE(07B0BH)  ! TrueType font mode (FONTMODE:xxx)
 ! PROPPRINT:collate         EQUATE(07B26H)  ! 0 or 1

                                    SELF.SetCurrentPrn(1)

                                    IF SELF.IsFieldValid(BitMask)

                                      CASE BitMask
                                        OF PrnFieldValue:Orientation
                                          ! No EQUATE in PRNPROPS for Orientation
                                          ! So we must set Whole Base DevMode Structure

                                          SELF.BDM.dmOrientation = Value
                                          PRINTER{PROPPRINT:DevMode} = SELF.BDM

                                        OF PrnFieldValue:PaperSize
                                          PRINTER{PROPPRINT:paper} = Value

                                        OF PrnFieldValue:PaperLength
                                          PRINTER{PROPPRINT:paperheight} = Value

                                        OF PrnFieldValue:PaperWidth
                                          PRINTER{PROPPRINT:paperwidth} = Value

                                        OF PrnFieldValue:Scale
                                          PRINTER{PROPPRINT:percent} = Value

                                        OF PrnFieldValue:Copies
                                          PRINTER{PROPPRINT:copies} = Value

                                        OF PrnFieldValue:DefaultSource
                                          PRINTER{PROPPRINT:paperbin} = Value

                                        OF PrnFieldValue:PrintQuality
                                          PRINTER{PROPPRINT:resolution} = Value

                                        OF PrnFieldValue:Color
                                          PRINTER{PROPPRINT:color} = Value

                                        OF PrnFieldValue:Duplex
                                          PRINTER{PROPPRINT:duplex} = Value

                                        OF PrnFieldValue:YResolution
                                          PRINTER{PROPPRINT:yresolution} = Value

                                        OF PrnFieldValue:TTOption
                                          PRINTER{PROPPRINT:FontMode} = Value

                                        OF PrnFieldValue:Collate
                                          PRINTER{PROPPRINT:collate} = Value

                                      END !CASE

                                      SELF.SetCurrentPrn()  ! force BDM and FDM refresh
                                    END !IF
                                  
                                    RETURN





